FName = 'RA_16ch_25kHz_1min';
load([FName '_SpikeShapes_1ms']);

NSpikes = size(SpikeShapes,1);
NChannels = size(SpikeShapes,2);
ls = size(SpikeShapes,3);

%take first three PCA components from each channel
%[Z mu sigma] = zscore(A2);   %not needed because without scaling is better
NPComp = 3; %take 3 PCs
PComp = zeros(NSpikes,NChannels*NPComp); 
for I_t = 1:NChannels
  M = squeeze(SpikeShapes(:,I_t,:));  %5324x27
  [COEFF,SCORE] = princomp(M);
  PComp(:,(I_t-1)*NPComp+(1:NPComp)) = SCORE(:,1:NPComp);
end
%COEFF = inv(A);    %also not a good idea: it is better to use \A to convert
                    %components to the original space

%%
%take six wavelet coefficients with maximal Kolmororov-Smirnoff value
NInputs = 3;    %was 6, take six wavew coef for clustering from channel
scales = 4; %defauls number of scales for decomposition
Inputs = zeros(NSpikes,NChannels*NInputs);
sd = zeros(1,ls);
matlabpool
tic
for I_t = 1:NChannels
  cc = zeros(NSpikes,ls);  
  parfor J_t = 1:NSpikes  
    M = SpikeShapes(J_t,I_t,:);  %1x27
    [c,l] = wavedec(M,scales,'haar');
    cc(J_t,:) = c(1:ls);
  end         %4.360349 seconds 1 core
  
  %lets plot histograms of these coefficients
% figure(I_t); clf;
% for E_t = 1:27
%   subplot(9,3,E_t);
%   hist(cc(:,E_t),100);
% end    
  for J_t = 1:ls        %KS test for coefficient selection
    thr_dist =std(cc(:,J_t))*3;
    thr_dist_min = mean(cc(:,J_t))-thr_dist; 
    thr_dist_max = mean(cc(:,J_t))+thr_dist; 
    aux = cc(cc(:,J_t)>thr_dist_min & cc(:,J_t)<thr_dist_max,J_t);
    if length(aux)>10
      ksstat = test_ks(aux); %- old style replace with kstest(x)
      sd(J_t) = ksstat;
    else
      sd(J_t) = 0;
    end  
  end
  [max ind] = sort(sd);
  coeff(1:NInputs) = ind(ls:-1:ls-NInputs+1);
  Inputs(:,(I_t-1)*NInputs+(1:NInputs)) = cc(:,coeff);
end
matlabpool close
toc %12.901227 seconds 12 threads/6 cores
%%
figure(100); clf;
for E_t = 1:3
  subplot(3,1,E_t);
  hist(Inputs(:,7*NInputs+E_t),100);
  title(E_t);
end
%%
save([FName '_Features'],'PComp','Inputs','FName','SpikeChannel','SpikeLocation','sps');