FName = 'RA_16ch_25kHz_1min';
load([FName '_Features']); %contains: 'PComp','Inputs','FName','SpikeChannel','SpikeLocation','sps'

%let's try KlustaKwik first
ArKK1 = PComp;  %take principle components
%ArKK1 = zscore(Inputs(:,:));
%ArKK1 = zscore(Inputs(:,7*3+(1:3)));  %take wavelet coefficients, Zscored - KK gives very bad results!
fid = fopen(['A' '.fet.1'],'wt');
NColumns = size(ArKK1,2);
fprintf(fid,'%u\n',NColumns); %number of columns = 3Principle comp *4Channels
st = '';
for I_t = 1:(NColumns-1)
  st = [st '%f\t'];  
end
for I_t = 1:(size(ArKK1,1)-1)
  fprintf(fid,[st '%f\n'],ArKK1(I_t,:));  
end
fprintf(fid,[st '%f'],ArKK1(size(ArKK1,1),:));
fclose(fid);
MaxPossibleClusters = 50;%system(['./KlustaKwik ' FNames{AnimalNumber} ' 1' ' -UseFeatures 11111111111111111']);
os = getenv('OS');
if strcmpi(os,'Windows_NT')
    CString = 'KlustaKwik.exe ';
else
    CString = './KlustaKwik ';
end 
system([CString 'A' ' 1 -MaxPossibleClusters '...
         int2str(MaxPossibleClusters)...
         ' -MinClusters ' int2str(MaxPossibleClusters)...
         ' -MaxClusters ' int2str(MaxPossibleClusters)...
         ' -UseFeatures 111111111111111111111111111111111111111111111111111111111111111111111111111111']);
          %13ch*3=390 plus 1 for safety%6ch*4PrinCom was 5 - 5
          % was 10 10
%read cluster number file
Clusters = uint8(dlmread(['A' '.clu.1']));
NClusters = Clusters(1);
Clusters(1) = [];
%%
%let's compute number of members in each cluster
NMembers = zeros(1,NClusters);
for I_t = 1:length(Clusters)
 Cluster = Clusters(I_t);
 NMembers(Cluster) = NMembers(Cluster)+1;
end
st = 'Members:';
for I_t = 1:NClusters
  st = [st ' ' num2str(NMembers(I_t))];    
end  
disp(st);
%%
%load wave shapes
load([FName '_SpikeShapes_1ms']);

%let's arrange neurons in cells
C = cell(1,NClusters);
CCounter = zeros(1,NClusters);
for I_t = 1:NClusters
  C{I_t} = zeros(NMembers(I_t),size(SpikeShapes,2),size(SpikeShapes,3));  
end  
for I_t = 1:size(SpikeShapes,1)
  Cluster = Clusters(I_t);
  CCounter(Cluster) = CCounter(Cluster)+1;
  C{Cluster}(CCounter(Cluster),:,:) = SpikeShapes(I_t,:,:);
end
%let's compute median and quartiles for each cell (for each neuron)
Medians = zeros(NClusters,size(SpikeShapes,2),size(SpikeShapes,3));
for I_t = 1:NClusters
  Medians(I_t,:,:) = median(C{I_t},1);  
end 

%let's plot wave shapes
%%
Shift = 25; %uV, introduced just for nice plotting, the first channel is at the top 
nchannels = 13;
Delta = (0:nchannels)*Shift;
Bt1 = zeros(size(Medians));
for I_t = 1:nchannels
  Bt1(:,I_t,:) = Medians(:,I_t,:)-Delta(I_t);  
end 

nc = double(NClusters);
X = (-13:1:13)/sps*1000; %in ms
figure(100); clf
for I_t = 1:nc
  subplot(1,nc,I_t);
  Mt = squeeze(Bt1(I_t,:,:));   %13x27
  
  plot(X,Mt','linewidth',2);
  xlim([X(1) X(end)]);
  title(['#' num2str(NMembers(I_t))]);
end    
    
    
    