function [ Y ] = filtfiltGPU( b,a,X )
%The same as filtfilt , but on GPUs, single precision for speed
%If double precision is needed just replace "single" with "double"
%in three places
%X = (time points, channels)
if size(X,1)==1
  X = X';
  Flip = true;
else
  Flip = false; 
end    
Y = zeros(size(X));  %just to reserve memory
NGPUs = gpuDeviceCount; 
gpuDevice(NGPUs);   %to take the last without monitors
A_shortGPU = gpuArray(single(b));
A1_shortGPU = gpuArray(single(a));
for I_t = 1:size(X,2) %13 channels
  A_longGPU = gpuArray(single(X(:,I_t)));
  R0 = filter(A_shortGPU,A1_shortGPU,A_longGPU);
  R = gather(R0);
  A_longGPU = gpuArray(flipud(R));
  R0 = filter(A_shortGPU,A1_shortGPU,A_longGPU);
  Y(:,I_t) = flipud(gather(R0));
  %disp(num2str(I_t));   %to show progress
end
%end GPU filtration

%now add small missed pieces at the beginning and at the end
%to be fully identical to filtfilt
T = filtfilt(b,a,double(X(1:(3*length(b)),:)));
Y(1:length(b),:) = T(1:length(b),:);
T = filtfilt(b,a,double(X(end-3*length(b)+(1:(3*length(b))),:)));
Y(end-length(b)+(1:length(b)),:) = T(end-length(b)+(1:length(b)),:);

if Flip
  Y = Y';  
end    
end

